using System;
using System.Collections.Generic;
using OSI.API.Business.Database;
using OSI.API.Business.Objects;

namespace OSI.API.Business.DAO
{

    public abstract class DAOBase<T> : MySQL
    {
        protected DAOBase(DBConnectionInformation connectionInformation) : base(connectionInformation)
        {
        }

        protected DAOBase(string server, string database, string username, string password) : base(server, database, username, password)
        {
        }

        public abstract List<T> GetAll();
        public abstract T Get(int id);
        public abstract void Create(T itemToCreate);
        public abstract void Update(T itemToUpdate);
        public abstract void Delete(int id);
    }

}